/*****************************************************************************
    -  
       :
        . 

		Copyright (c) 

 Project:  CFG_ANAL_DOS
 FileName: CFG_ANAL_DOS.PRO
 Purpose: No description
 Written by:  ..
 Comments:
******************************************************************************/

include "cfg_anal_dos.inc"

domains

    str_list=string*
    char_list=char*
    sentence=sentence(subject_phrase,predicate_phrase)
    subject_phrase=subject_phrase(def_list,subject);
                   homog_subject_phrase(subject_list)
    predicate_phrase=predicate_phrase(predicate,addition)
    subject=noun(string);
            pronoun(string)
    particle=particle(string)
    verb=verb(string)
    predicate=verb(string);
              predicate(particle,verb)
    def_list=definition*
    subject_list=subject*
    definition=adjective(string);
               participle(string)
    addition=noun(string);
             pronoun(string)

predicates

    member(char,char_list)
    match(String)
    nondeterm noun(string)
    nondeterm pronoun(string)
    nondeterm verb(string)
    nondeterm adjective(string)
    participle(string)
    particle(string)
    assert_database
    clear_database
    nondeterm symbol_counter(string,integer).
    nondeterm fronttoken_cyr(string,string,string).
    nondeterm del_front_space(string,string).
    nondeterm toklist(string,str_list).
    sentex(str_list,sentence).
    nondeterm subj_phrase(str_list,str_list,subject_phrase).
    nondeterm pred_phrase(str_list,predicate_phrase).
    nondeterm def_list_make(str_list,def_list,str_list).
    subj_list_make(str_list,subject_list,str_list).
    print_list(str_list).
    process(integer).
    analyse_it.
    do_cfg.
    nondeterm analyse_sentence(string).

clauses

/*     */

     do_cfg:-
             assert_database,
             makewindow(1,7,7,
             "       -",
             0,0,25,80),
             nl,nl,write("1 -     . "),nl,
                   write("2 -   ."),
             readint(Choice),
             process(Choice),
             do_cfg.

/*     */

     process(1):-analyse_it.
     process(2):-clear_database,exit.

/*    */

     analyse_it:-clearwindow,
                 write("       : "),
                 nl,readln(Line),analyse_sentence(Line),!.
     analyse_it:-clearwindow,!.

/*    */

     analyse_sentence(Line):-
                 clearwindow,
                 toklist(Line,Tklist),
                 sentex(Tklist,Sent_model),
                 write("  : ",Line),nl,
                 write("  : "),nl,
                 print_list(Tklist),nl,
                 write("  : "),nl,
                 write(Sent_model),nl,
                 write(" Enter  ..."),
                 readchar(_).
     analyse_sentence(_).

/*    */

     member(Head,[Head|_]):-!.
     member(Elem,[_|T]):-
             member(Elem,T).

/*    */

     print_list([]).
     print_list([Head|Tail]):-
             write("  ",Head),nl,
             print_list(Tail).

/*      */

     assert_database:-
             noun(Noun),
             assertz(d_noun(Noun)),fail.

     assert_database:-
             pronoun(Pronoun),
             assertz(d_pronoun(Pronoun)),fail.

     assert_database:-
             verb(Verb),
             assertz(d_verb(Verb)),fail.

     assert_database:-
             adjective(Adjective),
             assertz(d_adjective(Adjective)),fail.

     assert_database:-
             participle(Participle),
             assertz(d_participle(Participle)),fail.

     assert_database:-
             particle(Particle),
             assertz(d_particle(Particle)),fail.

     assert_database:-!.

/*   */

     clear_database:-
             retract(d_noun(_)),
             fail.

     clear_database:-
             retract(d_pronoun(_)),
             fail.

     clear_database:-
             retract(d_verb(_)),
             fail.

     clear_database:-
             retract(d_adjective(_)),
             fail.

     clear_database:-
             retract(d_participle(_)),
             fail.

     clear_database:-
             retract(d_particle(_)),
             fail.

     clear_database:-!.

/*       ,   ,
     ,  , !,",#,$ */

     symbol_counter(Str,0):-
             frontchar(Str,'\32',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\10',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\13',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\33',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\34',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\35',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\36',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\44',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\59',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\46',_),!.
     symbol_counter("",0).
     symbol_counter(Str,Number):-
             frontchar(Str,Char,Rest_of_string),
             symbol_counter(Rest_of_string,Number1),
             Number=Number1+1.

/*      */

     fronttoken_cyr(Str,Token,Rest_of_string):-
             symbol_counter(Str,Number),
             frontstr(Number,Str,Token,Rest_of_string).

/*      */

     del_front_space("","").
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\32',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\10',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\13',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\33',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\34',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\35',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\36',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\44',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\59',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\46',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Arg):-frontchar(Arg,Char,_),
                               not(member(Char,['\32','\10','\13','\33',
                                                '\34','\35','\36',
                                                '\44','\59','\46'])).

/*           */

     toklist("",[]):-!.
     toklist(Str,[Head|Tail]):-
             fronttoken_cyr(Str,Head,Str2),
             match(Head),!,
             del_front_space(Str2,Str1),
             toklist(Str1,Tail).

/*      */

    match(W):-d_noun(W),!.
    match(W):-d_pronoun(W),!.
    match(W):-d_verb(W),!.
    match(W):-d_adjective(W),!.
    match(W):-d_participle(W),!.
    match(W):-d_particle(W),!.
    match(W):-write(" : \34",W,"\34   ."),nl,
              write(" Enter  ..."),
              readchar(_).
              
/*    */

    sentex(Tklist,sentence(Subject_phrase,Predicate_phrase)):-
              subj_phrase(Tklist,Tklist1,Subject_phrase),
              pred_phrase(Tklist1,Predicate_phrase),!.
    sentex(_,_):-
              write("  . "),nl,
              write(" Enter  ..."),
              readchar(_),fail.

/*     */

    subj_phrase(Tklist,Tklist1,subject_phrase(Def_list,noun(Subject))):-
              def_list_make(Tklist,Def_list,[Subject|Tklist1]),
              d_noun(Subject).

    subj_phrase(Tklist,Tklist1,subject_phrase(Def_list,pronoun(Subject))):-
              def_list_make(Tklist,Def_list,[Subject|Tklist1]),
              d_pronoun(Subject).
              
    subj_phrase(Tklist,Tklist1,homog_subject_phrase(Subject_list)):-
              subj_list_make(Tklist,Subject_list,Tklist1).
              
/*     */

    def_list_make([Word|Tklist],[],[Word|Tklist]):-
              not(d_adjective(Word)),not(d_participle(Word)).
              
    def_list_make([Word|Tklist],[adjective(Word)|Res_list],Tklist1):-
              d_adjective(Word),!,
              def_list_make(Tklist,Res_list,Tklist1).
              
    def_list_make([Word|Tklist],[participle(Word)|Res_list],Tklist1):-
              d_participle(Word),!,
              def_list_make(Tklist,Res_list,Tklist1).
    
/*     */

    subj_list_make([Word|Tklist],[noun(Word)|Res_list],Tklist1):-
              d_noun(Word),!,
              subj_list_make(Tklist,Res_list,Tklist1).
    subj_list_make([Word|Tklist],[pronoun(Word)|Res_list],Tklist1):-
              d_pronoun(Word),!,
              subj_list_make(Tklist,Res_list,Tklist1).
    subj_list_make([Word|Tklist],[],[Word|Tklist]):-
              not(d_noun(Word)),not(d_pronoun(Word)).

/*     */

    pred_phrase([Verb|[Addition]],predicate_phrase(verb(Verb),noun(Addition))):-
              d_verb(Verb),d_noun(Addition).

    pred_phrase([Verb|[Addition]],predicate_phrase(verb(Verb),pronoun(Addition))):-
              d_verb(Verb),d_pronoun(Addition).
              
    pred_phrase([Particle|[Verb|[Addition]]],
                predicate_phrase(predicate(particle(Particle),verb(Verb)),noun(Addition))):-
              d_verb(Verb),d_particle(Particle),
              d_noun(Addition).

    pred_phrase([Particle|[Verb|[Addition]]],
                predicate_phrase(predicate(particle(Particle),verb(Verb)),pronoun(Addition))):-
              d_verb(Verb),d_particle(Particle),
              d_pronoun(Addition).

/*  */

    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    verb("").
    verb("").
    verb("").
    verb("").
    adjective("").
    adjective("").
    participle("").
    pronoun("").
    pronoun("").
    particle("").
    
goal

    do_cfg.