/*****************************************************************************
           
     

		Copyright (c) 

 Project:  KEY_WRDS_DOS
 FileName: KEY_WRDS_DOS.PRO
 Purpose: No description
 Written by:  ..
 Comments:
******************************************************************************/

include "key_wrds_dos.inc"

domains

    address=address(zip,country,region,city,street,house)
    name,zip,country,region,city,street,house,phone,fax=symbol
    name_list=name*
    char_list=char*

predicates

     member(char,char_list).
     nondeterm symbol_counter(string,integer).
     nondeterm fronttoken_cyr(string,string,string).
     nondeterm convers(string,name_list).
     nondeterm del_front_space(string,string).
     nondeterm last_element(name_list,symbol).
     nondeterm manufacturer(name,address,phone,fax).
     do_name.
     assert_database.
     clear_database.

clauses

/*    */

     member(Head,[Head|_]):-!.
     member(Elem,[_|T]):-
             member(Elem,T).

/*        
    dmanufacturer */
   
     assert_database:-
             manufacturer(Name,Address,Phone,Fax),
             assertz(dmanufacturer(Name,Address,Phone,Fax)),fail.
     assert_database:-!.

/*   */

     clear_database:-
             retract(dmanufacturer(_,_,_,_)),
             fail.
     clear_database:-!.

/*       ,   ,
     ,  , !,",#,$ */

     symbol_counter(Str,0):-
             frontchar(Str,'\32',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\10',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\13',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\33',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\34',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\35',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\36',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\44',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\59',_),!.
     symbol_counter("",0).
     symbol_counter(Str,Number):-
             frontchar(Str,Char,Rest_of_string),
             symbol_counter(Rest_of_string,Number1),
             Number=Number1+1.

/*      */

     fronttoken_cyr(Str,Token,Rest_of_string):-
             symbol_counter(Str,Number),
             frontstr(Number,Str,Token,Rest_of_string).

/*      */

     del_front_space("","").
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\32',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\10',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\13',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\33',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\34',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\35',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\36',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\44',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\59',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Arg):-frontchar(Arg,Char,_),
                               not(member(Char,['\32','\10','\13','\33',
                                                '\34','\35','\36',
                                                '\44','\59'])).

/*      
    */

     convers("",[]):-!.
     convers(Str,[Head|Tail]):-
             fronttoken_cyr(Str,Head,Str2),
             del_front_space(Str2,Str1),
             convers(Str1,Tail).

/*         .
       -  */

     last_element([Head],Last_element):-
             Last_element=Head.
     last_element([_|Tail],Last_element):-
             last_element(Tail,Last_element).
             
/*       */

     do_name:-
             dmanufacturer(Name,_,_,_),
             Full_name=Name,
             convers(Full_name,Name_component_list),
             last_element(Name_component_list,Factory_name),
             write(" : ",Factory_name),nl,fail.
     do_name:-write("      2003 ."),nl.
     
/*   */

     manufacturer(" ",
                    address("173004",""," ",
                            " ",". ","2/13"),
                   "(81622) 31736","(81622) 33286").
     manufacturer("  ",
                    address("173000",""," ",
                            " ",
                            ". -","73/1"),
                   "(81622) 27117","(81622) 24333").
     manufacturer("  ",
                    address("175200",""," ",
                            " ",".","24"),
                   "(81652) 27460","(81652) 35682").
     manufacturer(" ",
                    address("173008",""," ",
                            " ",".","15"),
                   "(8162) 640951","(8162) 643049").

goal

     assert_database,
     makewindow(1,7,7,"",0,0,25,80),
     makewindow(2,7,7,"  ",
                2,10,22,55),
     nl,nl,
     do_name,
     write(" Enter  ..."),nl,
     readchar(_),
     clear_database.
