/*****************************************************************************

		Copyright (c) 

 Project:  CFG_ANAL_WIN
 FileName: CFG_ANAL_WIN.PRO
 Purpose: No description
 Written by:  ..
 Comments:
******************************************************************************/

include "cfg_anal_win.inc"
include "cfg_anal_win.con"
include "hlptopic.con"

%BEGIN_WIN Task Window
/***************************************************************************
		Event handling for Task Window
***************************************************************************/

domains

    char_list=char*
    sentence=sentence(subject_phrase,predicate_phrase)
    subject_phrase=subject_phrase(def_list,subject);
                   homog_subject_phrase(subject_list)
    predicate_phrase=predicate_phrase(predicate,addition)
    subject=noun(string);
            pronoun(string)
    particle=particle(string)
    verb=verb(string)
    predicate=verb(string);
              predicate(particle,verb)
    def_list=definition*
    subject_list=subject*
    definition=adjective(string);
               participle(string)
    addition=noun(string);
             pronoun(string)

predicates

  task_win_eh : EHANDLER
     rev(char_list,char_list,char_list).
     reverse(char_list,char_list).
     member(char,char_list).
     nondeterm symbol_counter(string,integer).
     nondeterm del_front_space(string,string).
     nondeterm fronttoken_cyr(string,string,string).
     nondeterm str_char_list(string,char_list).
     pack(char_list,string).
     match(String)
     nondeterm noun(string)
     nondeterm pronoun(string)
     nondeterm verb(string)
     nondeterm adjective(string)
     participle(string)
     particle(string)
     assert_database
     clear_database
     nondeterm toklist(string,slist).
     sentex(slist,sentence).
     nondeterm subj_phrase(slist,slist,subject_phrase).
     nondeterm pred_phrase(slist,predicate_phrase).
     nondeterm def_list_make(slist,def_list,slist).
     subj_list_make(slist,subject_list,slist).
     nondeterm analyse_sentence(WINDOW Parent,string).

constants

%BEGIN Task Window, CreateParms, 21:23:16-22.12.2007, Code automatically updated!
  task_win_Flags = [wsf_SizeBorder,wsf_TitleBar,wsf_Close,wsf_Maximize,wsf_Minimize,wsf_ClipSiblings]
  task_win_Menu  = res_menu(idr_task_menu)
  task_win_Title = "    "
  task_win_Help  = idh_contents
%END Task Window, CreateParms

clauses

/*   */

     rev([],Init,Init).
     rev([H|T],Init,Res):-
        rev(T,[H|Init],Res).
        
     reverse(Arg,Res):-
        rev(Arg,[],Res).

/*    */

     member(Head,[Head|_]):-!.
     member(Elem,[_|T]):-
             member(Elem,T).

/*       ,   ,
     ,  , !,",#,$ */

     symbol_counter(Str,0):-
             frontchar(Str,'\32',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\10',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\13',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\33',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\34',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\35',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\36',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\40',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\41',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\44',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\45',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\46',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\59',_),!.
     symbol_counter("",0).
     symbol_counter(Str,Number):-
             frontchar(Str,_Char,Rest_of_string),
             symbol_counter(Rest_of_string,Number1),
             Number=Number1+1.

/*      */

     fronttoken_cyr(Str,Token,Rest_of_string):-
             symbol_counter(Str,Number),
             frontstr(Number,Str,Token,Rest_of_string).

/*      */

     del_front_space("","").
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\32',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\10',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\13',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\33',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\34',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\35',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\36',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\44',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\40',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\41',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\45',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\46',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\59',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Arg):-frontchar(Arg,Char,_),
                               not(member(Char,['\32','\10','\13','\33',
                                                '\34','\35','\36','\40','\41',
                                                '\44','\45','\46','\59'])).

/*      */

     str_char_list("",[]).

     str_char_list(Word,[Char|Char_List]):-
             frontchar(Word,Char,WordRest),
             str_char_list(WordRest,Char_List).

/*      */

     pack([],"").

     pack([H|T],Res):-
             str_char(Str_H,H),
             pack(T,Res1),
             concat(Str_H,Res1,Res).

/*    */

     analyse_sentence(_Win,Line):-
                 toklist(Line,Tklist),
                 sentex(Tklist,Sent_model),
                 term_str(slist,Tklist,Tklist_str),
                 str_char_list(Tklist_str,[_|Tklist_str_char_repr]),
                 reverse(Tklist_str_char_repr,[_|Tklist_str_char_repr_rev]),
                 reverse(Tklist_str_char_repr_rev,Tklist_str_char_repr1),
                 pack(Tklist_str_char_repr1,Tklist_str1),
                 dlg_Note("  : ",Line),
                 dlg_Note("  : ",Tklist_str1),
                 term_str(sentence,Sent_model,Sent_model_str),
                 win___Create(_Win,Sent_model_str).
     analyse_sentence(_,_).

/*      */

     assert_database:-
             noun(Noun),
             assertz(d_noun(Noun)),fail.

     assert_database:-
             pronoun(Pronoun),
             assertz(d_pronoun(Pronoun)),fail.

     assert_database:-
             verb(Verb),
             assertz(d_verb(Verb)),fail.

     assert_database:-
             adjective(Adjective),
             assertz(d_adjective(Adjective)),fail.

     assert_database:-
             participle(Participle),
             assertz(d_participle(Participle)),fail.

     assert_database:-
             particle(Particle),
             assertz(d_particle(Particle)),fail.

     assert_database:-!.

/*   */

     clear_database:-
             retract(d_noun(_)),
             fail.

     clear_database:-
             retract(d_pronoun(_)),
             fail.

     clear_database:-
             retract(d_verb(_)),
             fail.

     clear_database:-
             retract(d_adjective(_)),
             fail.

     clear_database:-
             retract(d_participle(_)),
             fail.

     clear_database:-
             retract(d_particle(_)),
             fail.

     clear_database:-!.

/*           */

     toklist("",[]):-!.
     toklist(Str,[Head|Tail]):-
             fronttoken_cyr(Str,Head,Str2),
             match(Head),!,
             del_front_space(Str2,Str1),
             toklist(Str1,Tail).

/*      */

    match(W):-d_noun(W),!.
    match(W):-d_pronoun(W),!.
    match(W):-d_verb(W),!.
    match(W):-d_adjective(W),!.
    match(W):-d_participle(W),!.
    match(W):-d_particle(W),!.
    match(W):-concat(" : \34",W,Temp),
              concat(Temp,"\34   .",Msg),
              dlg_Error(Msg),fail.
              
/*    */

    sentex(Tklist,sentence(Subject_phrase,Predicate_phrase)):-
              subj_phrase(Tklist,Tklist1,Subject_phrase),
              pred_phrase(Tklist1,Predicate_phrase),!.
    sentex(_,_):-
              write("  . "),nl,
              write(" Enter  ..."),
              readchar(_),fail.

/*     */

    subj_phrase(Tklist,Tklist1,subject_phrase(Def_list,noun(Subject))):-
              def_list_make(Tklist,Def_list,[Subject|Tklist1]),
              d_noun(Subject).

    subj_phrase(Tklist,Tklist1,subject_phrase(Def_list,pronoun(Subject))):-
              def_list_make(Tklist,Def_list,[Subject|Tklist1]),
              d_pronoun(Subject).
              
    subj_phrase(Tklist,Tklist1,homog_subject_phrase(Subject_list)):-
              subj_list_make(Tklist,Subject_list,Tklist1).
              
/*     */

    def_list_make([Word|Tklist],[],[Word|Tklist]):-
              not(d_adjective(Word)),not(d_participle(Word)).
              
    def_list_make([Word|Tklist],[adjective(Word)|Res_list],Tklist1):-
              d_adjective(Word),!,
              def_list_make(Tklist,Res_list,Tklist1).
              
    def_list_make([Word|Tklist],[participle(Word)|Res_list],Tklist1):-
              d_participle(Word),!,
              def_list_make(Tklist,Res_list,Tklist1).
    
/*     */

    subj_list_make([Word|Tklist],[noun(Word)|Res_list],Tklist1):-
              d_noun(Word),!,
              subj_list_make(Tklist,Res_list,Tklist1).
    subj_list_make([Word|Tklist],[pronoun(Word)|Res_list],Tklist1):-
              d_pronoun(Word),!,
              subj_list_make(Tklist,Res_list,Tklist1).
    subj_list_make([Word|Tklist],[],[Word|Tklist]):-
              not(d_noun(Word)),not(d_pronoun(Word)).

/*     */

    pred_phrase([Verb|[Addition]],predicate_phrase(verb(Verb),noun(Addition))):-
              d_verb(Verb),d_noun(Addition).

    pred_phrase([Verb|[Addition]],predicate_phrase(verb(Verb),pronoun(Addition))):-
              d_verb(Verb),d_pronoun(Addition).
              
    pred_phrase([Particle|[Verb|[Addition]]],
                predicate_phrase(predicate(particle(Particle),verb(Verb)),noun(Addition))):-
              d_verb(Verb),d_particle(Particle),
              d_noun(Addition).

    pred_phrase([Particle|[Verb|[Addition]]],
                predicate_phrase(predicate(particle(Particle),verb(Verb)),pronoun(Addition))):-
              d_verb(Verb),d_particle(Particle),
              d_pronoun(Addition).

/*  */

    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    noun("").
    verb("").
    verb("").
    verb("").
    verb("").
    adjective("").
    adjective("").
    participle("").
    pronoun("").
    pronoun("").
    particle("").
    
%BEGIN Task Window, e_Create
  task_win_eh(_Win,e_Create(_),0):-!,
%BEGIN Task Window, InitControls, 21:23:16-22.12.2007, Code automatically updated!
%END Task Window, InitControls
%BEGIN Task Window, ToolbarCreate, 21:23:16-22.12.2007, Code automatically updated!
	tb_project_toolbar_Create(_Win),
	tb_help_line_Create(_Win),
%END Task Window, ToolbarCreate
ifdef use_message
	msg_Create(100),
enddef
	!.
%END Task Window, e_Create

%MARK Task Window, new events

%BEGIN Task Window, id_file
  task_win_eh(_Win,e_Menu(id_file,_ShiftCtlAlt),0):-!,
        clear_database,
        assert_database,
	Line=dlg_GetStr("    -","       : ",""),
	analyse_sentence(_Win,Line),!.
	
%END Task Window, id_file

%BEGIN Task Window, id_help_contents
  task_win_eh(_Win,e_Menu(id_help_contents,_ShiftCtlAlt),0):-!,
  	vpi_ShowHelp("cfg_anal_win.hlp"),
	!.
%END Task Window, id_help_contents

%BEGIN Task Window, id_help_about
  task_win_eh(Win,e_Menu(id_help_about,_ShiftCtlAlt),0):-!,
	dlg_about_dialog_Create(Win),
	!.
%END Task Window, id_help_about

%BEGIN Task Window, id_file_exit
  task_win_eh(Win,e_Menu(id_file_exit,_ShiftCtlAlt),0):-!,
  	win_Destroy(Win),
        clear_database,!.
        
%END Task Window, id_file_exit

%BEGIN Task Window, e_Size
  task_win_eh(_Win,e_Size(_Width,_Height),0):-!,
ifdef use_tbar
	toolbar_Resize(_Win),
enddef
ifdef use_message
	msg_Resize(_Win),
enddef
	!.
%END Task Window, e_Size

%END_WIN Task Window

/***************************************************************************
		Invoking on-line Help
***************************************************************************/

  project_ShowHelpContext(HelpTopic):-
  	vpi_ShowHelpContext("cfg_anal_win.hlp",HelpTopic).

/***************************************************************************
			Main Goal
***************************************************************************/

goal

ifdef use_mdi
  vpi_SetAttrVal(attr_win_mdi,b_true),
enddef
ifdef ws_win
  ifdef use_3dctrl
    vpi_SetAttrVal(attr_win_3dcontrols,b_true),
  enddef
enddef  
  vpi_Init(task_win_Flags,task_win_eh,task_win_Menu,"cfg_anal_win",task_win_Title).

%BEGIN_TLB Project toolbar, 21:19:04-21.12.2007, Code automatically updated!
/**************************************************************************
	Creation of toolbar: Project toolbar
**************************************************************************/

clauses

  tb_project_toolbar_Create(_Parent):-
ifdef use_tbar
	toolbar_create(tb_top,0xC0C0C0,_Parent,
		[tb_ctrl(id_file_new,pushb,idb_new_up,idb_new_dn,idb_new_up,"New;New file",1,1),
		 tb_ctrl(id_file_open,pushb,idb_open_up,idb_open_dn,idb_open_up,"Open;Open file",1,1),
		 tb_ctrl(id_file_save,pushb,idb_save_up,idb_save_dn,idb_save_up,"Save;File save",1,1),
		 separator,
		 tb_ctrl(id_edit_undo,pushb,idb_undo_up,idb_undo_dn,idb_undo_up,"Undo;Undo",1,1),
		 tb_ctrl(id_edit_redo,pushb,idb_redo_up,idb_redo_dn,idb_redo_up,"Redo;Redo",1,1),
		 separator,
		 tb_ctrl(id_edit_cut,pushb,idb_cut_up,idb_cut_dn,idb_cut_up,"Cut;Cut to clipboard",1,1),
		 tb_ctrl(id_edit_copy,pushb,idb_copy_up,idb_copy_dn,idb_copy_up,"Copy;Copy to clipboard",1,1),
		 tb_ctrl(id_edit_paste,pushb,idb_paste_up,idb_paste_dn,idb_paste_up,"Paste;Paste from clipboard",1,1),
		 separator,
		 separator,
		 tb_ctrl(id_help_contents,pushb,idb_help_up,idb_help_down,idb_help_up,"Help;Help",1,1)]),
enddef
	true.
%END_TLB Project toolbar

%BEGIN_TLB Help line, 21:19:04-21.12.2007, Code automatically updated!
/**************************************************************************
	Creation of toolbar: Help line
**************************************************************************/

clauses

  tb_help_line_Create(_Parent):-
ifdef use_tbar
	toolbar_create(tb_bottom,0xC0C0C0,_Parent,
		[tb_text(idt_help_line,tb_context,452,0,4,10,0x0,"")]),
enddef
	true.
%END_TLB Help line

%BEGIN_DLG About dialog
/**************************************************************************
	Creation and event handling for dialog: About dialog
**************************************************************************/

constants

%BEGIN About dialog, CreateParms, 21:24:56-21.12.2007, Code automatically updated!
  dlg_about_dialog_ResID = idd_dlg_about
  dlg_about_dialog_DlgType = wd_Modal
  dlg_about_dialog_Help = idh_contents
%END About dialog, CreateParms

predicates

  dlg_about_dialog_eh : EHANDLER

clauses

  dlg_about_dialog_Create(Parent):-
	win_CreateResDialog(Parent,dlg_about_dialog_DlgType,dlg_about_dialog_ResID,dlg_about_dialog_eh,0).

%BEGIN About dialog, idc_ok _CtlInfo
  dlg_about_dialog_eh(_Win,e_Control(idc_ok,_CtrlType,_CtrlWin,_CtrlInfo),0):-!,
	win_Destroy(_Win),
	!.
%END About dialog, idc_ok _CtlInfo
%MARK About dialog, new events

  dlg_about_dialog_eh(_,_,_):-!,fail.

%END_DLG About dialog

