/*****************************************************************************

		Copyright (c) 

 Project:  NL_DBASE_WIN
 FileName: NL_DBASE_WIN.PRO
 Purpose: -   
 Written by:  ..
 Comments:
******************************************************************************/

include "nl_dbase_win.inc"
include "nl_dbase_win.con"
include "hlptopic.con"

%BEGIN_WIN Task Window
/***************************************************************************
		Event handling for Task Window
***************************************************************************/

predicates

  task_win_eh : EHANDLER
     assert_database.
     clear_database.
     erase.
     nondeterm last_element(slist,string).
     first_element(slist,string).
     access_database(WINDOW Parent,string).
     search_manufacturer(WINDOW Parent,string).
     nondeterm manufacturer(string,address,string,string).
     do_right_form(WINDOW Parent,string,string).
     keyword(string).
     member(char,char_list).
     nondeterm symbol_counter(string,integer).
     nondeterm del_front_space(string,string).
     nondeterm fronttoken_cyr(string,string,string).
     nondeterm convers(string,slist)
     nondeterm upper_lower_cyr(string,string).
     nondeterm upper_lower_cyr_convers(char_list,char_list).
     nondeterm str_char_list(string,char_list).
     pack(char_list,string).
     address_transform_to_string(address,string).

constants

%BEGIN Task Window, CreateParms, 21:21:00-22.12.2007, Code automatically updated!
  task_win_Flags = [wsf_SizeBorder,wsf_TitleBar,wsf_Close,wsf_Maximize,wsf_Minimize,wsf_ClipSiblings]
  task_win_Menu  = res_menu(idr_task_menu)
  task_win_Title = "      "
  task_win_Help  = idh_contents
%END Task Window, CreateParms

clauses

/*        
    dmanufacturer */
   
     assert_database:-
             manufacturer(Name,Address,Phone,Fax),
             assertz(dmanufacturer(Name,Address,Phone,Fax)),fail.
     assert_database:-!.

/*   */

     clear_database:-
             retract(dmanufacturer(_,_,_,_)),
             fail.
             
     clear_database:-!.

/*      
      "-" */

     erase:-retract(_),fail.
     erase.

/*    */

     member(Head,[Head|_]):-!.
     member(Elem,[_|T]):-
             member(Elem,T).

/*       ,   ,
     ,  , !,",#,$ */

     symbol_counter(Str,0):-
             frontchar(Str,'\32',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\10',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\13',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\33',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\34',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\35',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\36',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\40',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\41',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\44',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\45',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\46',_),!.
     symbol_counter(Str,0):-
             frontchar(Str,'\59',_),!.
     symbol_counter("",0).
     symbol_counter(Str,Number):-
             frontchar(Str,_Char,Rest_of_string),
             symbol_counter(Rest_of_string,Number1),
             Number=Number1+1.

/*      */

     fronttoken_cyr(Str,Token,Rest_of_string):-
             symbol_counter(Str,Number),
             frontstr(Number,Str,Token,Rest_of_string).

/*      */

     del_front_space("","").
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\32',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\10',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\13',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\33',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\34',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\35',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\36',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\44',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\40',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\41',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\45',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\46',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Res):-
             frontchar(Arg,Char,Res1),Char='\59',!,
             del_front_space(Res1,Res).
     del_front_space(Arg,Arg):-frontchar(Arg,Char,_),
                               not(member(Char,['\32','\10','\13','\33',
                                                '\34','\35','\36','\40','\41',
                                                '\44','\45','\46','\59'])).

/*      
    */

     convers("",[]):-!.
     convers(Str,[Head1|Tail]):-
             fronttoken_cyr(Str,Head,Str2),
             upper_lower_cyr(Head,Head1),
             del_front_space(Str2,Str1),
             convers(Str1,Tail).

/*  upper_lower   Windows */

     upper_lower_cyr(InString,OutString):-
             str_char_list(InString,Char_List_for_InString),
             upper_lower_cyr_convers(Char_List_for_InString,Char_List_for_OutString),
             pack(Char_List_for_OutString,OutString).

     upper_lower_cyr_convers([],[]).

     upper_lower_cyr_convers([Char|Char_List],[Char1|Char_List1]):-
             char_int(Char,ASCII_code),
             ASCII_code>=192,ASCII_code<=223,!,
             ASCII_code_new=ASCII_code+32,
             char_int(Char1,ASCII_code_new),
             upper_lower_cyr_convers(Char_List,Char_List1).

     upper_lower_cyr_convers([Char|Char_List],[Char1|Char_List1]):-
             char_int(Char,ASCII_code),
             ASCII_code=168,!,
             ASCII_code_new=ASCII_code+16,
             char_int(Char1,ASCII_code_new),
             upper_lower_cyr_convers(Char_List,Char_List1).

     upper_lower_cyr_convers([Char|Char_List],[Char1|Char_List1]):-
             char_int(Char,ASCII_code),
             ASCII_code>=65,ASCII_code<=90,!,
             ASCII_code_new=ASCII_code+32,
             char_int(Char1,ASCII_code_new),
             upper_lower_cyr_convers(Char_List,Char_List1).

     upper_lower_cyr_convers([Char|Char_List],[Char|Char_List1]):-
             upper_lower_cyr_convers(Char_List,Char_List1).

/*      */

     str_char_list("",[]).

     str_char_list(Word,[Char|Char_List]):-
             frontchar(Word,Char,WordRest),
             str_char_list(WordRest,Char_List).

/*      */

     pack([],"").

     pack([H|T],Res):-
             str_char(Str_H,H),
             pack(T,Res1),
             concat(Str_H,Res1,Res).

/*         .
       -  */

     last_element([Head],Last_element):-
             Last_element=Head.
     last_element([_|Tail],Last_element):-
             last_element(Tail,Last_element).
             
/*         . */

     first_element([Head|_],First_element):-
             First_element=Head.

/*       */

     access_database(_Win,Factory_name):-
             search_manufacturer(_Win,Factory_name).

/*      */

     address_transform_to_string(address(Zip,Country,Region,City,Street,House),AdrStrRepr):-
             concat(Zip,", ",Temp),
             concat(Temp,Country,Temp1),
             concat(Temp1,", ",Temp2),
             concat(Temp2,Region,Temp3),
             concat(Temp3,", ",Temp4),
             concat(Temp4,City,Temp5),
             concat(Temp5,", ",Temp6),
             concat(Temp6,Street,Temp7),
             concat(Temp7,", ",Temp8),
             concat(Temp8,House,AdrStrRepr).

/*   */

     search_manufacturer(_Win,Factory_name):-
             dmanufacturer(Name,Address,Phone,Fax),
             Full_name=Name,
             convers(Full_name,F_list),
             last_element(F_list,F_name),
             Factory_name=F_name,
             address_transform_to_string(Address,AdrStrRepr),
             concat("  \34",Name,Temp),
             concat(Temp,"\34    : ",Temp1),
             concat(Temp1,AdrStrRepr,Temp2),
             concat(Temp2,".",Temp3),
             concat(Temp3,"   : ",Temp4),
             concat(Temp4,Phone,Temp5),
             concat(Temp5,".",Temp6),
             concat(Temp6,"  : ",Temp7),
             concat(Temp7,Fax,Temp8),
             concat(Temp8,".",Result),
             win___Create(_Win,Result),!.

     search_manufacturer(_,Factory_name):-
             not(dummy),
             concat("   : ",Factory_name,Temp),
             concat(Temp,"    ",Result),
             dlg_Error(Result).
             
/*      */

     do_right_form(_Win,Kname,Lname):-
             keyword(Kname),
             concat("   ",Kname,Temp),
             concat(Temp,"   ",Temp1),
             concat(Temp1,Lname,Kwrds),
             dlg_Note("   : ",Kwrds),
             access_database(_Win,Lname),!.
             
     do_right_form(_,Kname,_):-
             frontstr(3,Kname,Word,_),
             Word="",!,
             exit.

     do_right_form(_,Kname,_):-
             frontstr(3,Kname,Word,_),
             Word="",!,
             exit.

     do_right_form(_,Kname,_):-
             frontstr(3,Kname,Word,_),
             Word="",!,
             exit.

     do_right_form(_,Kname,_):-
             frontstr(3,Kname,Word,_),
             Word="",!,
             exit.

     do_right_form(_,Kname,_):-
             upper_lower_cyr(Kname,Word),
             Word="exit",!,
             exit.

     do_right_form(_,Kname,_):-
             upper_lower_cyr(Kname,Word),
             Word="quit",!,
             exit.
             
/*     */

     do_right_form(_,Kname,_):-
             concat("    : ",Kname,Temp),
             concat(Temp,"   .",Temp1),
             concat(Temp1," .",Msg),
             dlg_Error(Msg),
             assertz(dummy),!.
     
/*     */

     keyword(Key):-
             frontstr(3,Key,Word,_),
             Word="",!.
     keyword(Key):-
             frontstr(3,Key,Word,_),
             Word="",!.
     keyword(Key):-
             frontstr(4,Key,Word,_),
             Word="",!.
     keyword(Key):-
             frontstr(4,Key,Word,_),
             Word="",!.             
     keyword(Key):-
             frontstr(4,Key,Word,_),
             Word="",!.
     keyword(Key):-
             frontstr(4,Key,Word,_),
             Word="",!.
             
/*   */

     manufacturer(" ",
                    address("173004",""," ",
                            " ",". ","2/13"),
                   "(81622) 31736","(81622) 33286").
     manufacturer("  ",
                    address("173000",""," ",
                            " ",
                            ". -","73/1"),
                   "(81622) 27117","(81622) 24333").
     manufacturer("  ",
                    address("175200",""," ",
                            " ",".","24"),
                   "(81652) 27460","(81652) 35682").
     manufacturer(" ",
                    address("173008",""," ",
                            " ",".","15"),
                   "(8162) 640951","(8162) 643049").

%BEGIN Task Window, e_Create
  task_win_eh(_Win,e_Create(_),0):-!,
%BEGIN Task Window, InitControls, 21:21:00-22.12.2007, Code automatically updated!
%END Task Window, InitControls
%BEGIN Task Window, ToolbarCreate, 21:21:00-22.12.2007, Code automatically updated!
	tb_project_toolbar_Create(_Win),
	tb_help_line_Create(_Win),
%END Task Window, ToolbarCreate
ifdef use_message
	msg_Create(100),
enddef
	!.
%END Task Window, e_Create

%MARK Task Window, new events

%BEGIN Task Window, id_file
  task_win_eh(_Win,e_Menu(id_file,_ShiftCtlAlt),0):-!,
        erase,
        assert_database,
	Sentence=dlg_GetStr("  ","   : "," "),
	convers(Sentence,List),
        first_element(List,Kname),
        last_element(List,Lname),
        do_right_form(_Win,Kname,Lname),
	clear_database,!.
	
%END Task Window, id_file

%BEGIN Task Window, id_help_contents
  task_win_eh(_Win,e_Menu(id_help_contents,_ShiftCtlAlt),0):-!,
  	vpi_ShowHelp("nl_dbase_win.hlp"),
	!.
%END Task Window, id_help_contents

%BEGIN Task Window, id_help_about
  task_win_eh(Win,e_Menu(id_help_about,_ShiftCtlAlt),0):-!,
	dlg_about_dialog_Create(Win),
	!.
%END Task Window, id_help_about

%BEGIN Task Window, id_file_exit
  task_win_eh(Win,e_Menu(id_file_exit,_ShiftCtlAlt),0):-!,
  	win_Destroy(Win),erase,
	!.
%END Task Window, id_file_exit

%BEGIN Task Window, e_Size
  task_win_eh(_Win,e_Size(_Width,_Height),0):-!,
ifdef use_tbar
	toolbar_Resize(_Win),
enddef
ifdef use_message
	msg_Resize(_Win),
enddef
	!.
%END Task Window, e_Size

%END_WIN Task Window

/***************************************************************************
		Invoking on-line Help
***************************************************************************/

  project_ShowHelpContext(HelpTopic):-
  	vpi_ShowHelpContext("nl_dbase_win.hlp",HelpTopic).

/***************************************************************************
			Main Goal
***************************************************************************/

goal

ifdef use_mdi
  vpi_SetAttrVal(attr_win_mdi,b_true),
enddef
ifdef ws_win
  ifdef use_3dctrl
    vpi_SetAttrVal(attr_win_3dcontrols,b_true),
  enddef
enddef  
  vpi_Init(task_win_Flags,task_win_eh,task_win_Menu,"nl_dbase_win",task_win_Title).

%BEGIN_TLB Project toolbar, 18:52:24-22.12.2007, Code automatically updated!
/**************************************************************************
	Creation of toolbar: Project toolbar
**************************************************************************/

clauses

  tb_project_toolbar_Create(_Parent):-
ifdef use_tbar
	toolbar_create(tb_top,0xC0C0C0,_Parent,
		[tb_ctrl(id_file_new,pushb,idb_new_up,idb_new_dn,idb_new_up,"New;New file",1,1),
		 tb_ctrl(id_file_open,pushb,idb_open_up,idb_open_dn,idb_open_up,"Open;Open file",1,1),
		 tb_ctrl(id_file_save,pushb,idb_save_up,idb_save_dn,idb_save_up,"Save;File save",1,1),
		 separator,
		 tb_ctrl(id_edit_undo,pushb,idb_undo_up,idb_undo_dn,idb_undo_up,"Undo;Undo",1,1),
		 tb_ctrl(id_edit_redo,pushb,idb_redo_up,idb_redo_dn,idb_redo_up,"Redo;Redo",1,1),
		 separator,
		 tb_ctrl(id_edit_cut,pushb,idb_cut_up,idb_cut_dn,idb_cut_up,"Cut;Cut to clipboard",1,1),
		 tb_ctrl(id_edit_copy,pushb,idb_copy_up,idb_copy_dn,idb_copy_up,"Copy;Copy to clipboard",1,1),
		 tb_ctrl(id_edit_paste,pushb,idb_paste_up,idb_paste_dn,idb_paste_up,"Paste;Paste from clipboard",1,1),
		 separator,
		 separator,
		 tb_ctrl(id_help_contents,pushb,idb_help_up,idb_help_down,idb_help_up,"Help;Help",1,1)]),
enddef
	true.
%END_TLB Project toolbar

%BEGIN_TLB Help line, 18:52:24-22.12.2007, Code automatically updated!
/**************************************************************************
	Creation of toolbar: Help line
**************************************************************************/

clauses

  tb_help_line_Create(_Parent):-
ifdef use_tbar
	toolbar_create(tb_bottom,0xC0C0C0,_Parent,
		[tb_text(idt_help_line,tb_context,452,0,4,10,0x0,"")]),
enddef
	true.
%END_TLB Help line

%BEGIN_DLG About dialog
/**************************************************************************
	Creation and event handling for dialog: About dialog
**************************************************************************/

constants

%BEGIN About dialog, CreateParms, 18:53:18-22.12.2007, Code automatically updated!
  dlg_about_dialog_ResID = idd_dlg_about
  dlg_about_dialog_DlgType = wd_Modal
  dlg_about_dialog_Help = idh_contents
%END About dialog, CreateParms

predicates

  dlg_about_dialog_eh : EHANDLER

clauses

  dlg_about_dialog_Create(Parent):-
	win_CreateResDialog(Parent,dlg_about_dialog_DlgType,dlg_about_dialog_ResID,dlg_about_dialog_eh,0).

%BEGIN About dialog, idc_ok _CtlInfo
  dlg_about_dialog_eh(_Win,e_Control(idc_ok,_CtrlType,_CtrlWin,_CtrlInfo),0):-!,
	win_Destroy(_Win),
	!.
%END About dialog, idc_ok _CtlInfo
%MARK About dialog, new events

  dlg_about_dialog_eh(_,_,_):-!,fail.

%END_DLG About dialog

